/* THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
 * ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
 * PARTICULAR PURPOSE.
 *
 * Copyright (C) 1994  Microsoft Corporation.  All Rights Reserved.
 *
 *  MODULE:   bunch.h
 *
 *  PURPOSE:
 *	  type definitions relating to bunches
 *
 *  COMMENTS:
 */


// BUNCHACTION tells the decompressor what to do with finished bunches

typedef enum tagBUNCHACTION
{
	DECOMPRESS,						// Put in output queue for later collection
	RECOMPRESS						// Put in local compressor's input queue
} BUNCHACTION;


typedef struct tagBUNCH				// bunch structure
{
	LONG			lBunchId;
	BUNCHACTION		baAction;
	LONG			lReturnStatus;
	LONG			lBunchLen;
	LPBITMAPINFO	lpbiCom;
	LPBITMAPINFO	lpbiUnc;
	LPBITMAPINFO	lpbiRec;
	LONG			*lplComIndex;
	DWORD			*lpadwRetFlags;
	LONG			lComDataLen;
	BYTE			*lpbComData;
	LONG			lUncDataLen;
	BYTE			*lpbUncData;
	LONG			nStat;			// 0 = free, 1 = queued, 2 = busy
	LONG			nNext;			// next queue member, -1 if last in queue 
} BUNCH, *LPBUNCH;


typedef struct tagBUNCHQUEUE		// queue of bunches
{
	LPBUNCH				abnchPool;
	LPCRITICAL_SECTION	lpcsPool;
	LONG				nQHead;
	CRITICAL_SECTION	csQ;
	DWORD				nQCnt;
	DWORD				nQLen;
	LONG				nPoolLen;
} BUNCHQUEUE, *LPBUNCHQUEUE;
