/* THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
 * ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
 * PARTICULAR PURPOSE.
 *
 * Copyright (C) 1994  Microsoft Corporation.  All Rights Reserved.
 *
 *  MODULE:   dcomp_c.h
 *
 *  PURPOSE:
 *	  main client-side header file for the Distributed Compression sample
 *
 *  COMMENTS:
 */

#include	"avi.h"
#include	"funcs_c.h"


// Constants

#define		MAXNUMSTREAMS		25
#define		MAXNAMETRIES		99
#define		MAXDECOMPSERVERS	25
#define		MAXCOMPSERVERS		25


// Global variables

#ifdef DEFINE_GLOBALS

#define GLOBAL   

int		gfDebug = FALSE;
DWORD	gdwOutCompression = mmioFOURCC('M', 'S', 'V', 'C');

#else

// only dcomp_c.c defines DEFINE_GLOBALS,
// all other references to these variables are extern

#define GLOBAL extern

#endif
	

// General

GLOBAL	TCHAR			gacBaseName[9];		// base name of this application
GLOBAL	TCHAR			gszComputerName[MAX_COMPUTERNAME_LENGTH + 1];
											// name of the local computer
GLOBAL	DWORD			gdwOSPlatformId;	// operating system ID


// Control flags

GLOBAL	int				gfHeapCommand;		// heap-check command invoked
GLOBAL	int				gfFindCommand;		// find servers command invoked
GLOBAL	int				gfDebug;			// enables debug print statement


// RPC-related

// Arrays of server names and RPC binding handles

GLOBAL	TCHAR			*gaszDecompServer[MAXDECOMPSERVERS];
GLOBAL	TCHAR			*gaszCompServer[MAXCOMPSERVERS];
GLOBAL	handle_t		gahDecomp[MAXDECOMPSERVERS];
GLOBAL	handle_t		gahComp[MAXCOMPSERVERS];

GLOBAL	LONG			lDecompSrvCnt;		// number of decompression servers
GLOBAL	LONG			lNextDecompSrv;		// next decompression server
GLOBAL	LONG			lCompSrvCnt;		// number of compression servers
GLOBAL	LONG			lNextCompSrv;		// next compresion server


// AVI-related

// Some of these should really be statics (or even locals) in avi.c

GLOBAL	TCHAR			*gszInputFileName;	// input AVI file name
GLOBAL	TCHAR			*gszOutputFileName;	// output AVI file name
GLOBAL	PAVIFILE		gpaviInFile;		// input AVI file-interface pointer
GLOBAL	PAVIFILE		gpaviOutFile;		// output AVI file-interface ptr.
GLOBAL	int				gcpavi;             // number of streams in input file
GLOBAL	DWORD			gdwOutCompression;	// requested output compression
GLOBAL	BUNCHACTION		gbaAction;			// decompression/recompression mode
GLOBAL	DWORD			gcbBufSize;			// size of buffer for copying
											// non-video data
GLOBAL	LONG			glVidStream;		// stream number of the video in
											// the input file

// Arrays of stream handles for input and output files

GLOBAL	PAVISTREAM		gapaviSrc[MAXNUMSTREAMS];
GLOBAL	PAVISTREAM		gapaviDest[MAXNUMSTREAMS];

// Video formats for compressed, uncompressed and recompressed data

GLOBAL	LPBITMAPINFO	glpbiCom;
GLOBAL	LPBITMAPINFO	glpbiUnc;
GLOBAL	LPBITMAPINFO	glpbiRec;
GLOBAL	LONG			glBiSize;			// size of video formats

